=== debian/control ===
Source: ros-one-cras-cpp-common
Section: misc
Priority: optional
Maintainer: Martin Pecka <peckama2@fel.cvut.cz>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libeigen3-dev, liburdfdom-headers-dev, ros-one-bondcpp, ros-one-catkin, ros-one-class-loader, ros-one-diagnostic-msgs, ros-one-diagnostic-updater, ros-one-dynamic-reconfigure, ros-one-filters, ros-one-gencpp, ros-one-geometry-msgs, ros-one-nodelet, ros-one-pluginlib, ros-one-rosconsole, ros-one-roscpp, ros-one-rosgraph-msgs, ros-one-sensor-msgs, ros-one-std-msgs, ros-one-tf2, ros-one-tf2-eigen, ros-one-tf2-geometry-msgs, ros-one-tf2-ros, ros-one-tf2-sensor-msgs, ros-one-topic-tools
Homepage: https://wiki.ros.org/cras_cpp_common
Standards-Version: 3.9.2

Package: ros-one-cras-cpp-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, liburdfdom-headers-dev, ros-one-bondcpp, ros-one-class-loader, ros-one-diagnostic-msgs, ros-one-diagnostic-updater, ros-one-dynamic-reconfigure, ros-one-filters, ros-one-geometry-msgs, ros-one-nodelet, ros-one-pluginlib, ros-one-rosconsole, ros-one-roscpp, ros-one-sensor-msgs, ros-one-tf2, ros-one-tf2-ros, ros-one-topic-tools
Description: A Czech-army knife for ROS code written in C++.
