## ros-one-cras-cpp-common 2.5.1-41noble.20251023.0828

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-41noble.20251023.0828) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 23 Oct 2025 08:28:29 +0000

ros-one-cras-cpp-common (2.5.1-0noble) noble; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 18 Feb 2025 00:00:00 -0000

ros-one-cras-cpp-common (2.5.0-0noble) noble; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 13 Feb 2025 00:00:00 -0000

ros-one-cras-cpp-common (2.4.8-0noble) noble; urgency=high

  * Added GetParamConvertingOptions() to ease defining converting getParam() that works with GCC 7.
  * Added NodeWithOptionalMaster.
  * Improved compatibility with newer compilers.
    Resolves https://github.com/RoboStack/ros-noetic/pull/501#issuecomment-2567224502 .
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Jan 2025 00:00:00 -0000

ros-one-cras-cpp-common (2.4.7-0noble) noble; urgency=high

  * Fixed installation of nodelet_manager_sharing_tf_buffer.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 12 Dec 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.6-0noble) noble; urgency=high

  * nodelet_utils: Allowed accessing the shared_ptr of the shared TF buffer.
  * node_from_nodelet: Worked around the bug where remapping private topics was impossible for anonymous nodes.
  * tf2_utils: Added TfMessageFilter compatible with log_utils.
  * time_utils: Added converters between ros::Time and struct tm.
  * Fixed a few printf format issues.
  * string_utils: Handle possible error in vsnprintf. Added printf-format attributes to cras::format() to enable compile-time checks of format strings.
  * string_utils: Added iconvConvert(), transliterateToAscii() and toValidRosName() functions.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 12 Dec 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.5-0noble) noble; urgency=high

  * string_utils: Added date/time parsing methods.
  * string_utils: Added methods for parsing integers with known radix.
  * diag_utils: Added tests for offline diag updater.
  * diag_utils: Added offline diag updater.
  * node_from_nodelet: Added support for stopping the node when requestStop() has been called in the nodelet code.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 02 Nov 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.4-0noble) noble; urgency=high

  * Fixed roslint.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 14 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.3-0noble) noble; urgency=high

  * Fixed build with ros_comm 1.17.0 .
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 14 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.2-0noble) noble; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 05 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.1-0noble) noble; urgency=high

  * Fixed roslint
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 04 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.0-0noble) noble; urgency=high

  * Added small_map and fixed concurrency problems in log_utils.
  * Updated fast_float to 6.1.5.
  * node_from_nodelet: Fixed error message
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 04 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.9-0noble) noble; urgency=high

  * Removed catkin_lint buildfarm hacks.
  * Updated to fast_float 6.1.0 .
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 27 Feb 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.8-0noble) noble; urgency=high

  * Fixed FindFilesystem CMake module usage of try_compile
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Fri, 12 Jan 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.7-0noble) noble; urgency=high

  * node_from_nodelet: Fix syntax for Melodic.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 09 Jan 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.6-0noble) noble; urgency=high

  * node_from_nodelet: Implemented a simplified version that doesn't need the nodelet header file.
  * node_from_nodelet: Fixed a bug with missing return 0 at the end of main.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 09 Jan 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.5-0noble) noble; urgency=high

  * param_utils: Added getParam() specialization for geometry_msgs/Pose messages.
  * nodelet_utils: Added Resettable interface to NodeletWithSharedTfBuffer.
  * Added Resettable interface compatible with cras_py_common.
  * time_utils: Added saturateAdd().
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 21 Nov 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.4-0noble) noble; urgency=high

  * Do not use -march=native optimizations for cras_tf2_sensor_msgs. More generic platform-specific optimizations are used.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 25 Oct 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.3-0noble) noble; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Fri, 06 Oct 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.2-0noble) noble; urgency=high

  * Fix finding std::filesystem in CMake if a non-default launguage standard is used.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Fri, 06 Oct 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.1-0noble) noble; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 13 Jul 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.0-0noble) noble; urgency=high

  * Increased minimum CMake version to 3.10.2.
  * log_utils: Fixed a potential segfault when instances of MemoryLogHelper get recycled.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 12 Jul 2023 00:00:00 -0000


