## ros-one-cras-cpp-common 2.5.1-125jammy.20260119.2100

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-125jammy.20260119.2100) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Mon, 19 Jan 2026 21:00:53 +0000
