## ros-one-cras-cpp-common 2.5.1-125noble.20260119.2059

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-125noble.20260119.2059) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Mon, 19 Jan 2026 20:59:02 +0000
