## ros-one-cras-cpp-common 2.5.1-140jammy.20260221.0114

=== CMakeLists.txt ===
--- 
+++ 
@@ -153,6 +153,10 @@
 target_sources(cras_span INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/span.hpp>)
 target_sources(cras_span INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/tcb/span.hpp>)
 
+add_library(cras_tqdm INTERFACE)
+target_sources(cras_tqdm INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/tqdm.hpp>)
+target_sources(cras_tqdm INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/tqdm/tqdm.hpp>)
+
 add_library(cras_small_map INTERFACE)
 target_sources(cras_small_map INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/small_map.hpp>)
 
@@ -228,7 +232,7 @@
 target_sources(cras_tf2_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/tf2_utils/message_filter.hpp>)
 add_dependencies(cras_tf2_utils ${catkin_EXPORTED_TARGETS})
 target_link_libraries(cras_tf2_utils
-  PUBLIC cras_log_utils cras_thread_utils cras_time_utils ${catkin_LIBRARIES})
+  PUBLIC cras_log_utils cras_thread_utils cras_time_utils cras_semaphore ${catkin_LIBRARIES})
 
 add_library(cras_string_utils src/string_utils.cpp src/string_utils/from_chars.cpp src/string_utils/ros.cpp)
 add_dependencies(cras_string_utils ${catkin_EXPORTED_TARGETS})
@@ -315,6 +319,3 @@
   PUBLIC cras_log_utils cras_optional cras_string_utils cras_type_utils xmlrpc_value_utils ${catkin_LIBRARIES}
   PRIVATE xmlrpc_value_traits)
 
-add_library(cras_filter_base INTERFACE)
-target_sources(cras_filter_base INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/filter_utils/filter_base.hpp>)
-target_link_libraries(cras_filter_base
